LSDIFF(1)

NAME
lsdiff - show which files are modified by a patch

SYNOPSIS

lsdiff [[-n] | [--line-number]] [[-p n] | [--strip-match=n]] [--strip=n] [--git-prefixes=strip|keep] [--git-extended-diffs=exclude|include] [--addprefix=PREFIX] [--addoldprefix=PREFIX] [--addnewprefix=PREFIX] [[-s] | [--status]] [[-E] | [--empty-files-as-removed]] [[-i PATTERN] | [--include=PATTERN]] [[-I FILE] | [--include-from-file=FILE]] [[-x PATTERN] | [--exclude=PATTERN]] [[-X FILE] | [--exclude-from-file=FILE]] [[-z] | [--decompress]] [[-# RANGE] | [--hunks=RANGE]] [--lines=RANGE] [[-FRANGE] | [--files=RANGE]] [[-H] | [--with-filename]] [[-h] | [--no-filename]] [[-v] | [--verbose]...] [file...]

lsdiff {[--help] | [--version] | [--filter ...] | [--grep ...]}

DESCRIPTION

List the files modified by a patch.

You can use unified, context, and Git format diffs with this program. Git format includes support for binary files, file renames, permission mode changes, and other Git-specific diff features.

OPTIONS

-n, --line-number
    Display the line number that each patch begins at. If verbose output is requested (using -nv), each hunk of each patch is listed as well.

    For each file that is modified, a line is generated containing the line number of the beginning of the patch, followed by a Tab character, followed by the name of the file that is modified. If -v is given once, following each of these lines will be one line for each hunk, consisting of a Tab character, the line number that the hunk begins at, another Tab character, the string “Hunk #”, and the hunk number (starting at 1).

    If the -v is given twice in conjunction with -n (i.e. -nvv), the format is slightly different: hunk-level descriptive text is shown after each hunk number, and the --number-files option is enabled.

-N, --number-files
    File numbers are listed, beginning at 1, before each filename.

-#RANGE, --hunks=RANGE
    Only list hunks within the specified RANGE. Hunks are numbered from 1, and the range is a comma-separated list of numbers or “first-last” spans, optionally preceded by a modifier 'x' which inverts the entire range; either the first or the last in the span may be omitted to indicate no limit in that direction.

--lines=RANGE
    Only list hunks that contain lines from the original file that lie within the specified RANGE. Lines are numbered from 1, and the range is a comma-separated list of numbers or “first-last” spans, optionally preceded by a modifier 'x' which inverts the entire range; either the first or the last in the span may be omitted to indicate no limit in that direction.

-F=RANGE, --files=RANGE
    Only list files indicated by the specified RANGE. Files are numbered from 1 in the order they appear in the patch input, and the range is a comma-separated list of numbers or “first-last” spans, optionally preceded by a modifier 'x' which inverts the entire range; either the first or the last in the span may be omitted to indicate no limit in that direction.

-pn, --strip-match=n
    When matching, ignore the first n components of the pathname.

--strip=n
    Remove the first n components of the pathname before displaying it.

--git-prefixes=strip|keep
    How to handle a/ and b/ prefixes in Git diff filenames. With strip, removes the prefixes both for filename matching (when using -i and -x options) and for filename output (similar to --strip). With keep (default), preserves existing behavior. Applies to both Git-specific diffs (binary files, renames, mode changes) and traditional diffs when part of a Git patch. Note: With keep, copy and rename operations are treated as if they had a/ and b/ prefixes for consistency with other Git operations. The default will change to strip in version 0.5.0.

--git-extended-diffs=exclude|include
    Controls whether to process Git diffs without traditional content hunks. This includes renames, copies, mode-only changes, and binary files. With exclude (default in 0.4.x), these diffs are skipped. With include (default in 0.5.0+), these diffs are processed normally. This option affects file numbering with -N and file filtering with -F.

--addprefix=PREFIX
    Prefix the pathname with PREFIX before displaying it.

--addoldprefix=PREFIX
    Prefix pathnames for old files with PREFIX before displaying them.

--addnewprefix=PREFIX
    Prefix pathnames for new files with PREFIX before displaying them.

-s, --status
    Show file additions, modifications and removals. A file addition is indicated by a “+”, a removal by a “-”, and a modification by a “!”.

-E, --empty-files-as-absent, --empty-files-as-removed
    Treat empty files as absent for the purpose of displaying file additions, modifications and removals. For example, a file with an empty old version and additions in the new version will be treated as a file addition (+) rather than a modification (!).

-iPATTERN, --include=PATTERN
    Include only files matching PATTERN.

-IFILE, --include-from-file=FILE
    Include only files matching any pattern listed in FILE, one pattern per line.

-xPATTERN, --exclude=PATTERN
    Exclude files matching PATTERN.

-XFILE, --exclude-from-file=FILE
    Exclude files matching any pattern listed in FILE, one pattern per line.

-z, --decompress
    Decompress files with extensions .gz and .bz2.

-H, --with-filename
    Print the name of the patch file containing each patch.

-h, --no-filename
    Suppress the name of the patch file containing each patch.

-v, --verbose
    Verbose output.

--help
    Display a short usage message.

--version
    Display the version number of lsdiff.

--filter
    Behave like filterdiff(1) instead.

--grep
    Behave like grepdiff(1) instead.

SEE ALSO

filterdiff(1), grepdiff(1), patchview(1)

EXAMPLES

To sort the order of touched files in a patch, you can use:

    lsdiff patch | sort -u | \
      xargs -rn1 filterdiff patch -i

To show only added files in a patch:

    lsdiff -s patch | grep '^+' | \
      cut -c2- | xargs -rn1 filterdiff patch -i

To show the headers of all file hunks:

    lsdiff -n patch | (while read n file
      do sed -ne "$n,$(($n+1))p" patch
    done)

AUTHOR

Tim Waugh <twaugh@redhat.com>
    Package maintainer